"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/tool-foundation/src/lib/schema.ts
var schema_exports = {};
__export(schema_exports, {
  loadSchema: () => loadSchema
});
module.exports = __toCommonJS(schema_exports);
var import_fs = require("fs");
var import_node_path = __toESM(require("node:path"));
var import_plugin_helpers = require("@graphql-codegen/plugin-helpers");
var import_schema = require("@graphql-tools/schema");
var import_glob = require("glob");
var import_graphql = require("graphql");
function getDocumentNodeFromAddToSchemaResult(a) {
  if (typeof a === "string") {
    return (0, import_graphql.parse)(a);
  }
  if (typeof a === "undefined") {
    return (0, import_graphql.parse)("");
  }
  return a;
}
function makeInitialSchema(addToSchemaResults) {
  const [first, ...rest] = Array.from(new Set(addToSchemaResults));
  return rest.reduce(
    (acc, next) => (0, import_graphql.extendSchema)(acc, getDocumentNodeFromAddToSchemaResult(next)),
    (0, import_graphql.buildASTSchema)(getDocumentNodeFromAddToSchemaResult(first))
  );
}
async function loadSchema(cwd, schemaGlob, addToSchemaResults) {
  const initialSchema = makeInitialSchema(addToSchemaResults);
  const patterns = Array.isArray(schemaGlob) ? schemaGlob : [schemaGlob];
  const files = (0, import_glob.globSync)(patterns, { cwd });
  const sources = files.map(
    (file) => new import_graphql.Source((0, import_fs.readFileSync)(import_node_path.default.resolve(cwd, file), "utf8"), file)
  );
  const typeDefs = sources.map((source) => (0, import_graphql.parse)(source, {}));
  return (0, import_plugin_helpers.getCachedDocumentNodeFromSchema)(
    (0, import_graphql.lexicographicSortSchema)(
      (0, import_schema.mergeSchemas)({ typeDefs: [initialSchema, ...typeDefs] })
    )
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  loadSchema
});
//# sourceMappingURL=schema.cjs.map
