// packages/@code-like-a-carpenter/tool-foundation/src/foundation.ts
import { assert } from "@code-like-a-carpenter/assert";
import { generateCode } from "./lib/index.mjs";
async function handler({
  outputs = ["cloudformation", "typescript"],
  ...rest
}) {
  const typesafe = outputs.map((o) => {
    assert(o === "cloudformation" || o === "typescript", `Invalid output ${o}`);
    return o;
  });
  return generateCode({ ...rest, outputs: typesafe });
}
export {
  handler
};
//# sourceMappingURL=foundation.mjs.map
